!Splitbar Resizing Methods
! Copyright 1999-2001 JNData, LLC
!
!  1-23-1999 -  First Revision of the Split Bar Manager
!  2-12-1999 -  Finished Template that calls this Class
!  2-15-1999 -  Bug fixes for use of this in C4
!  2-23-1999 -  Changed to consolidate C4 & C5 into one template. (INIT affected)
!  4-6-1999  -  Added Redraw while moving ability to the objects (Template will follow later.)
!  5-30-2000 -  Current Template Version 1.20 - No changes to this code.
! 11-11-2000 -  Added "EventsRegistered" boolean
! 02-28-2001 -  Added Pointer Bar Offset to keep wide/fat bars from "jumping" when first touched.
!               Added SavebarLook and ReSetbarLook methods as well as OrigColor,OrigFill, and OrigBevel Properties
!               used to save and restore the bar appearance.
! 02-28-2001 -  Issued new template version "1.25" for C4-C5.5
! 08-09-2001 -  Testing with C5.5 Patch 5
!            -  Revised to use Control FEQ Number when Registering the Event Handlers
!            -  Revised to use the MouseUp Event instead of the Drag Event that was not happening in C5.5 P5
!            -  Added the creation of a Panel control to "be the bar" when it is being moved.
! 08-10-2001 -  New Version of Template (1.26) to handle new Event (MouseUp).
! 08-15-2001 -  Revised "shadow" Panel Bevel display to match Region Bevels better.

!ABCIncludeFile

  OMIT('_EndOfInclude_',_JNDSplitManager_)
_JNDSplitManager_  EQUATE(1)

 !   INCLUDE('BUILTINS.CLW')   ! Needed for the REGISTEREVENT procedure. Compiler automatically
 !                             ! includes this, so this is just for documentation purposed.
 !                             ! That's why it is commented out.

JNDSplitQueue         QUEUE,TYPE
BarHandle               LONG
SplitType               BYTE   ! (See Itemize List below)
FEQ                     LONG   ! Field Equate label of the splitbar
RedrawWhileMoving       BYTE   ! (Self explaining field label)
EventsRegistered        BYTE   ! Events for this Bar Registered
                      END !Queue

JNDSplitFieldQueue    QUEUE,TYPE
BarHandle               LONG
FEQ                     LONG  ! Field Equate of the resizable object
Placement               BYTE  ! (See Itemized list below)
MoveFlag                BYTE  ! If TRUE then the field is being moved instead of resized
Offset                  LONG  ! Offset from the bar upon moving
                      END !QUEUE

                      ITEMIZE,PRE(JNDSplitType)
Horizontal              EQUATE(1)
Vertical                EQUATE

                      END !ITEMIZE

                      ITEMIZE,PRE(JNDSplitMove)
NorthSouth              EQUATE(1)
EastWest                EQUATE
                      END !ITEMIZE

                      ITEMIZE,PRE(JNDSplitPlacement)
Above                   EQUATE(1)
Below                   EQUATE
Left                    EQUATE
Right                   EQUATE
                      END !ITEMIZE


JNDSplitManagerClass  CLASS,MODULE('JNDsplit.CLW'),TYPE,LINK('JNDSplit.CLW',_ABCLinkMode_),DLL(_ABCDllMode_)
SQ                      &JNDSplitQueue
SFQ                     &JNDSplitFieldQueue
RegisterEvents      BYTE
    ! Following Variables are used while a splitbar is being moved
MovingSplit             BYTE  ! True or False
SplitBeingMoved         LONG  ! Handle of the Split
FEQBeingMoved           LONG  ! Field Equate of the Bar being moved
SplitBeingMovedRedraw   BYTE  ! Flag to tell if Split Being Moved needs to redraw as it is moved
MovingDirection         BYTE  ! (See above ITEMIZE list)
MinimumPos              LONG  ! Minimum position available during movement
MaximumPos              LONG  ! Maximum position available during movement
PointerBarOffset        LONG  ! Distance from Left/Upper edge of Bar and the Mouse Pointer - New 2-26-2001
EdgeBuffer              LONG  ! Space at extreme edge that should always be left
SaveCurrentPos          LONG  ! Save the CurrentPosition
NewBarPosX              LONG  ! New position of Bar during a move (X)
NewBarPosY              LONG  ! New position of Bar during a move (Y)
   !
OverlayBoxFEQ           LONG  ! Box (really a Panel) that overlays Position of Region to Reduce Flicker
OrigHide                LONG  ! Whether the Region is Hidden at start of movement
OrigColor               LONG  ! Original Outline Color of the Region at start of movement
OrigFill                LONG  ! Original Fill Color of the Region at start of movement
OrigBevel               LONG,DIM(3) ! Original Bevel of the Region at start of movement
    !
Init                    PROCEDURE(BYTE DontUseEventTrap=0)
Kill                    PROCEDURE()
AddVertSplit            PROCEDURE(LONG PassedFEQ),LONG  ! Returns Handle of the bar
AddHorzSplit            PROCEDURE(LONG PassedFEQ),LONG  ! Returns Handle of the bar
AddFieldServer          PROCEDURE(LONG BarHandle,LONG PassedFEQ,BYTE MoveFlag,BYTE Placement),BYTE
AddFieldAbove           PROCEDURE(LONG BarHandle,LONG PassedFEQ,<BYTE MoveFlag>),BYTE,PROC
AddFieldBelow           PROCEDURE(LONG BarHandle,LONG PassedFEQ,<BYTE MoveFlag>),BYTE,PROC
AddFieldLeft            PROCEDURE(LONG BarHandle,LONG PassedFEQ,<BYTE MoveFlag>),BYTE,PROC
AddFieldRight           PROCEDURE(LONG BarHandle,LONG PassedFEQ,<BYTE MoveFlag>),BYTE,PROC
SetBarRedrawFlag        PROCEDURE(LONG BarHandle,BYTE RedrawFlag)
SetMovingLimits         PROCEDURE(LONG BarHandle,BYTE Direction)
TakeDraggingEvent       PROCEDURE(),BYTE
TakeMouseUpEvent        PROCEDURE(),BYTE   ! Former TakeDragEvent Handler
TakeMouseMoveEvent      PROCEDURE(),BYTE
DraggingStarted         PROCEDURE(LONG BarHandle),VIRTUAL
DraggingStopped         PROCEDURE(LONG BarHandle),VIRTUAL
RedrawFields            PROCEDURE(LONG BarHandle,BYTE Final=0),VIRTUAL
GetFEQFromHandle        PROCEDURE(LONG BarHandle),LONG
SaveBarLook             PROCEDURE(LONG BarHandle),PROTECTED  ! Used internally
ReSetBarLook            PROCEDURE(LONG BarHandle),PROTECTED  ! Used internally
                      END !CLASS


_EndOfInclude_

